package hu.bme.mit.inf.socialnetwork.language.parser.antlr.internal; 

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import hu.bme.mit.inf.socialnetwork.language.services.SocialNetworkLanguageGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalSocialNetworkLanguageParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'social'", "'network'", "'{'", "'}'", "'community'", "'person'", "'communities'", "','", "'of'", "'friend'", "'relative'", "'college'"
    };
    public static final int RULE_ID=4;
    public static final int T__22=22;
    public static final int RULE_ANY_OTHER=10;
    public static final int T__21=21;
    public static final int T__20=20;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__19=19;
    public static final int RULE_STRING=6;
    public static final int T__16=16;
    public static final int T__15=15;
    public static final int T__18=18;
    public static final int T__17=17;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int T__14=14;
    public static final int T__13=13;
    public static final int RULE_INT=5;
    public static final int RULE_WS=9;

    // delegates
    // delegators


        public InternalSocialNetworkLanguageParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalSocialNetworkLanguageParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalSocialNetworkLanguageParser.tokenNames; }
    public String getGrammarFileName() { return "../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g"; }



     	private SocialNetworkLanguageGrammarAccess grammarAccess;
     	
        public InternalSocialNetworkLanguageParser(TokenStream input, SocialNetworkLanguageGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }
        
        @Override
        protected String getFirstRuleName() {
        	return "SocialNetwork";	
       	}
       	
       	@Override
       	protected SocialNetworkLanguageGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}



    // $ANTLR start "entryRuleSocialNetwork"
    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:68:1: entryRuleSocialNetwork returns [EObject current=null] : iv_ruleSocialNetwork= ruleSocialNetwork EOF ;
    public final EObject entryRuleSocialNetwork() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSocialNetwork = null;


        try {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:69:2: (iv_ruleSocialNetwork= ruleSocialNetwork EOF )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:70:2: iv_ruleSocialNetwork= ruleSocialNetwork EOF
            {
             newCompositeNode(grammarAccess.getSocialNetworkRule()); 
            pushFollow(FOLLOW_ruleSocialNetwork_in_entryRuleSocialNetwork75);
            iv_ruleSocialNetwork=ruleSocialNetwork();

            state._fsp--;

             current =iv_ruleSocialNetwork; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleSocialNetwork85); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSocialNetwork"


    // $ANTLR start "ruleSocialNetwork"
    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:77:1: ruleSocialNetwork returns [EObject current=null] : (otherlv_0= 'social' otherlv_1= 'network' () otherlv_3= '{' ( (lv_entities_4_0= ruleEntity ) )* otherlv_5= '}' ) ;
    public final EObject ruleSocialNetwork() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        EObject lv_entities_4_0 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:80:28: ( (otherlv_0= 'social' otherlv_1= 'network' () otherlv_3= '{' ( (lv_entities_4_0= ruleEntity ) )* otherlv_5= '}' ) )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:81:1: (otherlv_0= 'social' otherlv_1= 'network' () otherlv_3= '{' ( (lv_entities_4_0= ruleEntity ) )* otherlv_5= '}' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:81:1: (otherlv_0= 'social' otherlv_1= 'network' () otherlv_3= '{' ( (lv_entities_4_0= ruleEntity ) )* otherlv_5= '}' )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:81:3: otherlv_0= 'social' otherlv_1= 'network' () otherlv_3= '{' ( (lv_entities_4_0= ruleEntity ) )* otherlv_5= '}'
            {
            otherlv_0=(Token)match(input,11,FOLLOW_11_in_ruleSocialNetwork122); 

                	newLeafNode(otherlv_0, grammarAccess.getSocialNetworkAccess().getSocialKeyword_0());
                
            otherlv_1=(Token)match(input,12,FOLLOW_12_in_ruleSocialNetwork134); 

                	newLeafNode(otherlv_1, grammarAccess.getSocialNetworkAccess().getNetworkKeyword_1());
                
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:89:1: ()
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:90:5: 
            {

                    current = forceCreateModelElement(
                        grammarAccess.getSocialNetworkAccess().getSocialNetworkAction_2(),
                        current);
                

            }

            otherlv_3=(Token)match(input,13,FOLLOW_13_in_ruleSocialNetwork155); 

                	newLeafNode(otherlv_3, grammarAccess.getSocialNetworkAccess().getLeftCurlyBracketKeyword_3());
                
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:99:1: ( (lv_entities_4_0= ruleEntity ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( ((LA1_0>=15 && LA1_0<=16)) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:100:1: (lv_entities_4_0= ruleEntity )
            	    {
            	    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:100:1: (lv_entities_4_0= ruleEntity )
            	    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:101:3: lv_entities_4_0= ruleEntity
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getSocialNetworkAccess().getEntitiesEntityParserRuleCall_4_0()); 
            	    	    
            	    pushFollow(FOLLOW_ruleEntity_in_ruleSocialNetwork176);
            	    lv_entities_4_0=ruleEntity();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getSocialNetworkRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"entities",
            	            		lv_entities_4_0, 
            	            		"Entity");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            otherlv_5=(Token)match(input,14,FOLLOW_14_in_ruleSocialNetwork189); 

                	newLeafNode(otherlv_5, grammarAccess.getSocialNetworkAccess().getRightCurlyBracketKeyword_5());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSocialNetwork"


    // $ANTLR start "entryRuleEntity"
    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:129:1: entryRuleEntity returns [EObject current=null] : iv_ruleEntity= ruleEntity EOF ;
    public final EObject entryRuleEntity() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleEntity = null;


        try {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:130:2: (iv_ruleEntity= ruleEntity EOF )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:131:2: iv_ruleEntity= ruleEntity EOF
            {
             newCompositeNode(grammarAccess.getEntityRule()); 
            pushFollow(FOLLOW_ruleEntity_in_entryRuleEntity225);
            iv_ruleEntity=ruleEntity();

            state._fsp--;

             current =iv_ruleEntity; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleEntity235); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEntity"


    // $ANTLR start "ruleEntity"
    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:138:1: ruleEntity returns [EObject current=null] : (this_Community_0= ruleCommunity | this_Person_1= rulePerson ) ;
    public final EObject ruleEntity() throws RecognitionException {
        EObject current = null;

        EObject this_Community_0 = null;

        EObject this_Person_1 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:141:28: ( (this_Community_0= ruleCommunity | this_Person_1= rulePerson ) )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:142:1: (this_Community_0= ruleCommunity | this_Person_1= rulePerson )
            {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:142:1: (this_Community_0= ruleCommunity | this_Person_1= rulePerson )
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==15) ) {
                alt2=1;
            }
            else if ( (LA2_0==16) ) {
                alt2=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }
            switch (alt2) {
                case 1 :
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:143:5: this_Community_0= ruleCommunity
                    {
                     
                            newCompositeNode(grammarAccess.getEntityAccess().getCommunityParserRuleCall_0()); 
                        
                    pushFollow(FOLLOW_ruleCommunity_in_ruleEntity282);
                    this_Community_0=ruleCommunity();

                    state._fsp--;

                     
                            current = this_Community_0; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:153:5: this_Person_1= rulePerson
                    {
                     
                            newCompositeNode(grammarAccess.getEntityAccess().getPersonParserRuleCall_1()); 
                        
                    pushFollow(FOLLOW_rulePerson_in_ruleEntity309);
                    this_Person_1=rulePerson();

                    state._fsp--;

                     
                            current = this_Person_1; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEntity"


    // $ANTLR start "entryRuleCommunity"
    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:169:1: entryRuleCommunity returns [EObject current=null] : iv_ruleCommunity= ruleCommunity EOF ;
    public final EObject entryRuleCommunity() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleCommunity = null;


        try {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:170:2: (iv_ruleCommunity= ruleCommunity EOF )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:171:2: iv_ruleCommunity= ruleCommunity EOF
            {
             newCompositeNode(grammarAccess.getCommunityRule()); 
            pushFollow(FOLLOW_ruleCommunity_in_entryRuleCommunity344);
            iv_ruleCommunity=ruleCommunity();

            state._fsp--;

             current =iv_ruleCommunity; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleCommunity354); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleCommunity"


    // $ANTLR start "ruleCommunity"
    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:178:1: ruleCommunity returns [EObject current=null] : (otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_subcommunities_3_0= ruleCommunity ) )* otherlv_4= '}' )? ) ;
    public final EObject ruleCommunity() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        EObject lv_subcommunities_3_0 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:181:28: ( (otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_subcommunities_3_0= ruleCommunity ) )* otherlv_4= '}' )? ) )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:182:1: (otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_subcommunities_3_0= ruleCommunity ) )* otherlv_4= '}' )? )
            {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:182:1: (otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_subcommunities_3_0= ruleCommunity ) )* otherlv_4= '}' )? )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:182:3: otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_subcommunities_3_0= ruleCommunity ) )* otherlv_4= '}' )?
            {
            otherlv_0=(Token)match(input,15,FOLLOW_15_in_ruleCommunity391); 

                	newLeafNode(otherlv_0, grammarAccess.getCommunityAccess().getCommunityKeyword_0());
                
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:186:1: ( (lv_name_1_0= RULE_ID ) )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:187:1: (lv_name_1_0= RULE_ID )
            {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:187:1: (lv_name_1_0= RULE_ID )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:188:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleCommunity408); 

            			newLeafNode(lv_name_1_0, grammarAccess.getCommunityAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getCommunityRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:204:2: (otherlv_2= '{' ( (lv_subcommunities_3_0= ruleCommunity ) )* otherlv_4= '}' )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==13) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:204:4: otherlv_2= '{' ( (lv_subcommunities_3_0= ruleCommunity ) )* otherlv_4= '}'
                    {
                    otherlv_2=(Token)match(input,13,FOLLOW_13_in_ruleCommunity426); 

                        	newLeafNode(otherlv_2, grammarAccess.getCommunityAccess().getLeftCurlyBracketKeyword_2_0());
                        
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:208:1: ( (lv_subcommunities_3_0= ruleCommunity ) )*
                    loop3:
                    do {
                        int alt3=2;
                        int LA3_0 = input.LA(1);

                        if ( (LA3_0==15) ) {
                            alt3=1;
                        }


                        switch (alt3) {
                    	case 1 :
                    	    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:209:1: (lv_subcommunities_3_0= ruleCommunity )
                    	    {
                    	    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:209:1: (lv_subcommunities_3_0= ruleCommunity )
                    	    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:210:3: lv_subcommunities_3_0= ruleCommunity
                    	    {
                    	     
                    	    	        newCompositeNode(grammarAccess.getCommunityAccess().getSubcommunitiesCommunityParserRuleCall_2_1_0()); 
                    	    	    
                    	    pushFollow(FOLLOW_ruleCommunity_in_ruleCommunity447);
                    	    lv_subcommunities_3_0=ruleCommunity();

                    	    state._fsp--;


                    	    	        if (current==null) {
                    	    	            current = createModelElementForParent(grammarAccess.getCommunityRule());
                    	    	        }
                    	           		add(
                    	           			current, 
                    	           			"subcommunities",
                    	            		lv_subcommunities_3_0, 
                    	            		"Community");
                    	    	        afterParserOrEnumRuleCall();
                    	    	    

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop3;
                        }
                    } while (true);

                    otherlv_4=(Token)match(input,14,FOLLOW_14_in_ruleCommunity460); 

                        	newLeafNode(otherlv_4, grammarAccess.getCommunityAccess().getRightCurlyBracketKeyword_2_2());
                        

                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleCommunity"


    // $ANTLR start "entryRulePerson"
    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:238:1: entryRulePerson returns [EObject current=null] : iv_rulePerson= rulePerson EOF ;
    public final EObject entryRulePerson() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePerson = null;


        try {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:239:2: (iv_rulePerson= rulePerson EOF )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:240:2: iv_rulePerson= rulePerson EOF
            {
             newCompositeNode(grammarAccess.getPersonRule()); 
            pushFollow(FOLLOW_rulePerson_in_entryRulePerson498);
            iv_rulePerson=rulePerson();

            state._fsp--;

             current =iv_rulePerson; 
            match(input,EOF,FOLLOW_EOF_in_entryRulePerson508); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePerson"


    // $ANTLR start "rulePerson"
    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:247:1: rulePerson returns [EObject current=null] : (otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' otherlv_3= 'communities' otherlv_4= '{' ( ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}' ( (lv_acquaintaces_9_0= ruleAcquaintace ) )* otherlv_10= '}' ) ;
    public final EObject rulePerson() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_8=null;
        Token otherlv_10=null;
        EObject lv_acquaintaces_9_0 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:250:28: ( (otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' otherlv_3= 'communities' otherlv_4= '{' ( ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}' ( (lv_acquaintaces_9_0= ruleAcquaintace ) )* otherlv_10= '}' ) )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:251:1: (otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' otherlv_3= 'communities' otherlv_4= '{' ( ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}' ( (lv_acquaintaces_9_0= ruleAcquaintace ) )* otherlv_10= '}' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:251:1: (otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' otherlv_3= 'communities' otherlv_4= '{' ( ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}' ( (lv_acquaintaces_9_0= ruleAcquaintace ) )* otherlv_10= '}' )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:251:3: otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' otherlv_3= 'communities' otherlv_4= '{' ( ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}' ( (lv_acquaintaces_9_0= ruleAcquaintace ) )* otherlv_10= '}'
            {
            otherlv_0=(Token)match(input,16,FOLLOW_16_in_rulePerson545); 

                	newLeafNode(otherlv_0, grammarAccess.getPersonAccess().getPersonKeyword_0());
                
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:255:1: ( (lv_name_1_0= RULE_ID ) )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:256:1: (lv_name_1_0= RULE_ID )
            {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:256:1: (lv_name_1_0= RULE_ID )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:257:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePerson562); 

            			newLeafNode(lv_name_1_0, grammarAccess.getPersonAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getPersonRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            otherlv_2=(Token)match(input,13,FOLLOW_13_in_rulePerson579); 

                	newLeafNode(otherlv_2, grammarAccess.getPersonAccess().getLeftCurlyBracketKeyword_2());
                
            otherlv_3=(Token)match(input,17,FOLLOW_17_in_rulePerson591); 

                	newLeafNode(otherlv_3, grammarAccess.getPersonAccess().getCommunitiesKeyword_3());
                
            otherlv_4=(Token)match(input,13,FOLLOW_13_in_rulePerson603); 

                	newLeafNode(otherlv_4, grammarAccess.getPersonAccess().getLeftCurlyBracketKeyword_4());
                
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:285:1: ( ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==RULE_ID) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:285:2: ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )*
                    {
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:285:2: ( (otherlv_5= RULE_ID ) )
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:286:1: (otherlv_5= RULE_ID )
                    {
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:286:1: (otherlv_5= RULE_ID )
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:287:3: otherlv_5= RULE_ID
                    {

                    			if (current==null) {
                    	            current = createModelElement(grammarAccess.getPersonRule());
                    	        }
                            
                    otherlv_5=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePerson624); 

                    		newLeafNode(otherlv_5, grammarAccess.getPersonAccess().getCommunityCommunityCrossReference_5_0_0()); 
                    	

                    }


                    }

                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:298:2: (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )*
                    loop5:
                    do {
                        int alt5=2;
                        int LA5_0 = input.LA(1);

                        if ( (LA5_0==18) ) {
                            alt5=1;
                        }


                        switch (alt5) {
                    	case 1 :
                    	    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:298:4: otherlv_6= ',' ( (otherlv_7= RULE_ID ) )
                    	    {
                    	    otherlv_6=(Token)match(input,18,FOLLOW_18_in_rulePerson637); 

                    	        	newLeafNode(otherlv_6, grammarAccess.getPersonAccess().getCommaKeyword_5_1_0());
                    	        
                    	    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:302:1: ( (otherlv_7= RULE_ID ) )
                    	    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:303:1: (otherlv_7= RULE_ID )
                    	    {
                    	    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:303:1: (otherlv_7= RULE_ID )
                    	    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:304:3: otherlv_7= RULE_ID
                    	    {

                    	    			if (current==null) {
                    	    	            current = createModelElement(grammarAccess.getPersonRule());
                    	    	        }
                    	            
                    	    otherlv_7=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePerson657); 

                    	    		newLeafNode(otherlv_7, grammarAccess.getPersonAccess().getCommunityCommunityCrossReference_5_1_1_0()); 
                    	    	

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop5;
                        }
                    } while (true);


                    }
                    break;

            }

            otherlv_8=(Token)match(input,14,FOLLOW_14_in_rulePerson673); 

                	newLeafNode(otherlv_8, grammarAccess.getPersonAccess().getRightCurlyBracketKeyword_6());
                
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:319:1: ( (lv_acquaintaces_9_0= ruleAcquaintace ) )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( ((LA7_0>=20 && LA7_0<=22)) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:320:1: (lv_acquaintaces_9_0= ruleAcquaintace )
            	    {
            	    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:320:1: (lv_acquaintaces_9_0= ruleAcquaintace )
            	    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:321:3: lv_acquaintaces_9_0= ruleAcquaintace
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getPersonAccess().getAcquaintacesAcquaintaceParserRuleCall_7_0()); 
            	    	    
            	    pushFollow(FOLLOW_ruleAcquaintace_in_rulePerson694);
            	    lv_acquaintaces_9_0=ruleAcquaintace();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getPersonRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"acquaintaces",
            	            		lv_acquaintaces_9_0, 
            	            		"Acquaintace");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);

            otherlv_10=(Token)match(input,14,FOLLOW_14_in_rulePerson707); 

                	newLeafNode(otherlv_10, grammarAccess.getPersonAccess().getRightCurlyBracketKeyword_8());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePerson"


    // $ANTLR start "entryRuleAcquaintace"
    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:349:1: entryRuleAcquaintace returns [EObject current=null] : iv_ruleAcquaintace= ruleAcquaintace EOF ;
    public final EObject entryRuleAcquaintace() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAcquaintace = null;


        try {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:350:2: (iv_ruleAcquaintace= ruleAcquaintace EOF )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:351:2: iv_ruleAcquaintace= ruleAcquaintace EOF
            {
             newCompositeNode(grammarAccess.getAcquaintaceRule()); 
            pushFollow(FOLLOW_ruleAcquaintace_in_entryRuleAcquaintace743);
            iv_ruleAcquaintace=ruleAcquaintace();

            state._fsp--;

             current =iv_ruleAcquaintace; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleAcquaintace753); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAcquaintace"


    // $ANTLR start "ruleAcquaintace"
    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:358:1: ruleAcquaintace returns [EObject current=null] : ( ( (lv_type_0_0= ruleAcqType ) ) otherlv_1= 'of' ( (otherlv_2= RULE_ID ) ) ) ;
    public final EObject ruleAcquaintace() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Enumerator lv_type_0_0 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:361:28: ( ( ( (lv_type_0_0= ruleAcqType ) ) otherlv_1= 'of' ( (otherlv_2= RULE_ID ) ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:362:1: ( ( (lv_type_0_0= ruleAcqType ) ) otherlv_1= 'of' ( (otherlv_2= RULE_ID ) ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:362:1: ( ( (lv_type_0_0= ruleAcqType ) ) otherlv_1= 'of' ( (otherlv_2= RULE_ID ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:362:2: ( (lv_type_0_0= ruleAcqType ) ) otherlv_1= 'of' ( (otherlv_2= RULE_ID ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:362:2: ( (lv_type_0_0= ruleAcqType ) )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:363:1: (lv_type_0_0= ruleAcqType )
            {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:363:1: (lv_type_0_0= ruleAcqType )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:364:3: lv_type_0_0= ruleAcqType
            {
             
            	        newCompositeNode(grammarAccess.getAcquaintaceAccess().getTypeAcqTypeEnumRuleCall_0_0()); 
            	    
            pushFollow(FOLLOW_ruleAcqType_in_ruleAcquaintace799);
            lv_type_0_0=ruleAcqType();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getAcquaintaceRule());
            	        }
                   		set(
                   			current, 
                   			"type",
                    		lv_type_0_0, 
                    		"AcqType");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_1=(Token)match(input,19,FOLLOW_19_in_ruleAcquaintace811); 

                	newLeafNode(otherlv_1, grammarAccess.getAcquaintaceAccess().getOfKeyword_1());
                
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:384:1: ( (otherlv_2= RULE_ID ) )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:385:1: (otherlv_2= RULE_ID )
            {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:385:1: (otherlv_2= RULE_ID )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:386:3: otherlv_2= RULE_ID
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getAcquaintaceRule());
            	        }
                    
            otherlv_2=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleAcquaintace831); 

            		newLeafNode(otherlv_2, grammarAccess.getAcquaintaceAccess().getTargetPersonCrossReference_2_0()); 
            	

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAcquaintace"


    // $ANTLR start "ruleAcqType"
    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:405:1: ruleAcqType returns [Enumerator current=null] : ( (enumLiteral_0= 'friend' ) | (enumLiteral_1= 'relative' ) | (enumLiteral_2= 'college' ) ) ;
    public final Enumerator ruleAcqType() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;
        Token enumLiteral_2=null;

         enterRule(); 
        try {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:407:28: ( ( (enumLiteral_0= 'friend' ) | (enumLiteral_1= 'relative' ) | (enumLiteral_2= 'college' ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:408:1: ( (enumLiteral_0= 'friend' ) | (enumLiteral_1= 'relative' ) | (enumLiteral_2= 'college' ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:408:1: ( (enumLiteral_0= 'friend' ) | (enumLiteral_1= 'relative' ) | (enumLiteral_2= 'college' ) )
            int alt8=3;
            switch ( input.LA(1) ) {
            case 20:
                {
                alt8=1;
                }
                break;
            case 21:
                {
                alt8=2;
                }
                break;
            case 22:
                {
                alt8=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;
            }

            switch (alt8) {
                case 1 :
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:408:2: (enumLiteral_0= 'friend' )
                    {
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:408:2: (enumLiteral_0= 'friend' )
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:408:4: enumLiteral_0= 'friend'
                    {
                    enumLiteral_0=(Token)match(input,20,FOLLOW_20_in_ruleAcqType881); 

                            current = grammarAccess.getAcqTypeAccess().getFriendEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_0, grammarAccess.getAcqTypeAccess().getFriendEnumLiteralDeclaration_0()); 
                        

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:414:6: (enumLiteral_1= 'relative' )
                    {
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:414:6: (enumLiteral_1= 'relative' )
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:414:8: enumLiteral_1= 'relative'
                    {
                    enumLiteral_1=(Token)match(input,21,FOLLOW_21_in_ruleAcqType898); 

                            current = grammarAccess.getAcqTypeAccess().getRelativeEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_1, grammarAccess.getAcqTypeAccess().getRelativeEnumLiteralDeclaration_1()); 
                        

                    }


                    }
                    break;
                case 3 :
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:420:6: (enumLiteral_2= 'college' )
                    {
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:420:6: (enumLiteral_2= 'college' )
                    // ../hu.bme.mit.inf.socialnetwork.language/src-gen/hu/bme/mit/inf/socialnetwork/language/parser/antlr/internal/InternalSocialNetworkLanguage.g:420:8: enumLiteral_2= 'college'
                    {
                    enumLiteral_2=(Token)match(input,22,FOLLOW_22_in_ruleAcqType915); 

                            current = grammarAccess.getAcqTypeAccess().getCollegeEnumLiteralDeclaration_2().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_2, grammarAccess.getAcqTypeAccess().getCollegeEnumLiteralDeclaration_2()); 
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAcqType"

    // Delegated rules


 

    public static final BitSet FOLLOW_ruleSocialNetwork_in_entryRuleSocialNetwork75 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleSocialNetwork85 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_ruleSocialNetwork122 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_ruleSocialNetwork134 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_13_in_ruleSocialNetwork155 = new BitSet(new long[]{0x000000000001C000L});
    public static final BitSet FOLLOW_ruleEntity_in_ruleSocialNetwork176 = new BitSet(new long[]{0x000000000001C000L});
    public static final BitSet FOLLOW_14_in_ruleSocialNetwork189 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleEntity_in_entryRuleEntity225 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleEntity235 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_ruleEntity282 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePerson_in_ruleEntity309 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_entryRuleCommunity344 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleCommunity354 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_15_in_ruleCommunity391 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleCommunity408 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_13_in_ruleCommunity426 = new BitSet(new long[]{0x000000000000C000L});
    public static final BitSet FOLLOW_ruleCommunity_in_ruleCommunity447 = new BitSet(new long[]{0x000000000000C000L});
    public static final BitSet FOLLOW_14_in_ruleCommunity460 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePerson_in_entryRulePerson498 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRulePerson508 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_16_in_rulePerson545 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePerson562 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_13_in_rulePerson579 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_17_in_rulePerson591 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_13_in_rulePerson603 = new BitSet(new long[]{0x0000000000004010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePerson624 = new BitSet(new long[]{0x0000000000044000L});
    public static final BitSet FOLLOW_18_in_rulePerson637 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePerson657 = new BitSet(new long[]{0x0000000000044000L});
    public static final BitSet FOLLOW_14_in_rulePerson673 = new BitSet(new long[]{0x0000000000704000L});
    public static final BitSet FOLLOW_ruleAcquaintace_in_rulePerson694 = new BitSet(new long[]{0x0000000000704000L});
    public static final BitSet FOLLOW_14_in_rulePerson707 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleAcquaintace_in_entryRuleAcquaintace743 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleAcquaintace753 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleAcqType_in_ruleAcquaintace799 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_19_in_ruleAcquaintace811 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleAcquaintace831 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_20_in_ruleAcqType881 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_21_in_ruleAcqType898 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_22_in_ruleAcqType915 = new BitSet(new long[]{0x0000000000000002L});

}